//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 9
#property indicator_color1  DarkGray
#property indicator_color2  LimeGreen
#property indicator_color3  LimeGreen
#property indicator_color4  Orange
#property indicator_color5  Orange
#property indicator_color6  DimGray
#property indicator_color7  DimGray
#property indicator_color8  LimeGreen
#property indicator_color9  Orange
#property indicator_width1  2
#property indicator_width2  3
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  3
#property indicator_style6  STYLE_DOT
#property indicator_style7  STYLE_DOT

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame            = PERIOD_CURRENT;
extern int             AverageLength        = 30;
extern enPrices        AveragePrice         = pr_hamedian;
extern double          Variance             = 1;
extern double          Mean                 = 0.5;
extern double          ConfidenceLevel      = 85;
extern int             ConfidenceBandsShift = 3;
extern bool            alertsOn             = true;
extern bool            alertsOnCurrent      = true;
extern bool            alertsMessage        = true;
extern bool            alertsSound          = true;
extern bool            alertsNotify         = false;
extern bool            alertsEmail          = false;
extern string          soundFile            = "alert2.wav";
extern bool            Interpolate          = true;

extern bool            ArrowsOnFirstBar     = true;
extern int             arrowUpCode          = 217;
extern int             arrowDownCode        = 218;

double avg[];
double avgua[];
double avgub[];
double avgda[];
double avgdb[];
double avgeu[];
double avged[];
double arup[];
double ardn[];
double pr[];
double state[];
double coeffs[];
double ConfidenceZ;
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
// 
//
//
//
//

#define maxx 3.5
int init()
{
   IndicatorBuffers(11);
      SetIndexBuffer(0,avg);
      SetIndexBuffer(1,avgua);
      SetIndexBuffer(2,avgub);
      SetIndexBuffer(3,avgda);
      SetIndexBuffer(4,avgdb);
      SetIndexBuffer(5,avgeu);
      SetIndexBuffer(6,avged);
      SetIndexBuffer(7,arup); SetIndexStyle(7,DRAW_ARROW); SetIndexArrow(7,arrowUpCode);
      SetIndexBuffer(8,ardn); SetIndexStyle(8,DRAW_ARROW); SetIndexArrow(8,arrowDownCode);
      SetIndexBuffer(9,pr);
      SetIndexBuffer(10,state);
      
      //
      //
      //
      //
      //
         Variance          = MathMax(Variance,0.01);
         Mean              = MathMax(MathMin(Mean,1.0),-1.0);
         ArrayResize(coeffs,AverageLength);   
         double step       = maxx/(AverageLength-1); for(int i=0; i<AverageLength; i++) coeffs[i] = pdf(i*step,Variance,Mean*maxx);
         ConfidenceLevel   = MathMax(MathMin(ConfidenceLevel,99.9999999999),0.0000000001);
         ConfidenceZ       = NormalCDFInverse((ConfidenceLevel+(100-ConfidenceLevel)/2.0)/100.0);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);          
     
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(TimeFrame)+" Confidence bands of Pdfma ("+AverageLength+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { avg[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame==Period())
   {
     if (state[limit]== 1) CleanPoint(limit,avgua,avgub);
     if (state[limit]==-1) CleanPoint(limit,avgda,avgdb);
     for(int i=limit; i>=0; i--)
     {
        pr[i]  = getPrice(AveragePrice,Open,Close,High,Low,i);
        avg[i] = iPdfma(pr[i],AverageLength,coeffs,i);
              double dev = iDeviation(pr,AverageLength,avg[i+ConfidenceBandsShift],i+ConfidenceBandsShift);
              double me  = ConfidenceZ*dev/MathSqrt(AverageLength);
              avgeu[i]   = avg[i+ConfidenceBandsShift]+me;
              avged[i]   = avg[i+ConfidenceBandsShift]-me;
              avgua[i]   = EMPTY_VALUE;
              avgub[i]   = EMPTY_VALUE;
              avgda[i]   = EMPTY_VALUE;
              avgdb[i]   = EMPTY_VALUE;
              arup[i]    = EMPTY_VALUE;
              ardn[i]    = EMPTY_VALUE;
              state[i]   = 0;
              if (avg[i]>avgeu[i]) state[i] =  1;
              if (avg[i]<avged[i]) state[i] = -1;
              if (state[i]== 1) PlotPoint(i,avgua,avgub,avg);
              if (state[i]==-1) PlotPoint(i,avgda,avgdb,avg);
              if (state[i]!=state[i+1])
              {
                 if (state[i] ==  1) arup[i] = avg[i]-iATR(NULL,0,10,i);
                 if (state[i] == -1) ardn[i] = avg[i]+iATR(NULL,0,10,i);
              }
   }         
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (state[whichBar]!=state[whichBar+1])
      {
         if (state[whichBar] == -1) doAlert(whichBar,"down");
         if (state[whichBar] ==  1) doAlert(whichBar,"up");
      }         
   }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   int shift = -1; if (ArrowsOnFirstBar) shift=1;
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (state[limit]== 1) CleanPoint(limit,avgua,avgub);
   if (state[limit]==-1) CleanPoint(limit,avgda,avgdb);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      int x = iBarShift(NULL,TimeFrame,Time[i+shift]);  
         avg[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,AverageLength,AveragePrice,Variance,Mean,ConfidenceLevel,ConfidenceBandsShift,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile, 0,y);
         avgeu[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,AverageLength,AveragePrice,Variance,Mean,ConfidenceLevel,ConfidenceBandsShift,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile, 5,y);
         avged[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,AverageLength,AveragePrice,Variance,Mean,ConfidenceLevel,ConfidenceBandsShift,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile, 6,y);
         state[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,AverageLength,AveragePrice,Variance,Mean,ConfidenceLevel,ConfidenceBandsShift,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,10,y);
         avgua[i] = EMPTY_VALUE;
         avgub[i] = EMPTY_VALUE;
         avgda[i] = EMPTY_VALUE;
         avgdb[i] = EMPTY_VALUE;
      if (x!=y)
      {
         arup[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,AverageLength,AveragePrice,Variance,Mean,ConfidenceLevel,ConfidenceBandsShift,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,7,y);
         ardn[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,AverageLength,AveragePrice,Variance,Mean,ConfidenceLevel,ConfidenceBandsShift,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,8,y);
      }
      else
      {
          arup[i] = EMPTY_VALUE;
          ardn[i] = EMPTY_VALUE;
      }
         
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
  	            avg[i+k]   = avg[i]  +(avg[i+n]   - avg[i])   * k/n;
  	            avgeu[i+k] = avgeu[i]+(avgeu[i+n] - avgeu[i]) * k/n;
  	            avged[i+k] = avged[i]+(avged[i+n] - avged[i]) * k/n;
            }  	            
   }
   for(i=limit; i>=0; i--)
   {
      if (state[i]== 1) PlotPoint(i,avgua,avgub,avg);
      if (state[i]==-1) PlotPoint(i,avgda,avgdb,avg);
   }
return(0);
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double iDeviation(double& array[], double period, double ma, int i, bool isSample=true)
{
   double sum = 0.00; for(int k=0; k<period; k++) sum += MathPow((array[i+k]-ma),2);
   if (isSample)      
         return(MathSqrt(sum/(period-1.0)));
   else  return(MathSqrt(sum/period));
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//    normal probability density function
//
//

#define Pi 3.141592653589793238462643

double pdf(double x, double variance=1.0, double mean=0)
      { return((1.0/MathSqrt(2*Pi*MathPow(variance,2))*MathExp(-MathPow(x-mean,2)/(2*MathPow(variance,2))))); }

//
//
//
//
//

double workPdfma[][1];
double iPdfma(double price, double period, double& tcoeffs[], int r, int instanceNo=0)
{
   if (ArraySize(workPdfma)!= Bars) ArrayResize(workPdfma,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workPdfma[r][instanceNo] = price;
      double sumw = tcoeffs[0];
      double sum  = tcoeffs[0]*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = tcoeffs[k];
                sumw  += weight;
                sum   += weight*workPdfma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double RationalApproximation(double t)
{
    double c[] = {2.515517, 0.802853, 0.010328};
    double d[] = {1.432788, 0.189269, 0.001308};
    return (t - (( c[2]*t + c[1])*t + c[0]) / 
                (((d[2]*t + d[1])*t + d[0])*t + 1.0));
}
double NormalCDFInverse(double p)
{
    if (p <= 0.0 || p >= 1.0) return(0);
    if (p < 0.5)
           return (-RationalApproximation(MathSqrt(-2.0*MathLog(p))));
    else   return ( RationalApproximation(MathSqrt(-2.0*MathLog(1.0-p))));
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(TimeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," pdfma & confidence bands ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," pdfma & confidence bands "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}